#ifndef __COMPEL_BISECT_H__
#define __COMPEL_BISECT_H__

#include <sys/types.h>

enum tf {
	TRACE_INTERRUPT,
	TRACE_SYSCALL_ENTER,
	TRACE_SYSCALL_EXIT,
};

struct trace_flag {
	pid_t key;
	enum tf flag;
};

struct bisect_meta {
	int size;
	int used;
	void *data;	/* data pointer array */
	void *__data;	/* data array */
};

struct trace_flag *tf_bisect(struct bisect_meta *meta, pid_t key);
struct trace_flag *tf_insert(struct bisect_meta *meta, pid_t key);
int tf_create(struct bisect_meta *meta, int len);
void tf_destroy(struct bisect_meta *meta);
void tf_clear(struct bisect_meta *meta);

#endif /* __COMPEL_BISECT_H__ */
