#include <fcntl.h>
#include <stdbool.h>
#include <stdio.h>
#include <unistd.h>

#include "exit-notify.h"
#include "log.h"

int mask_task_exit_notify(int pid, bool mask)
{
	int fd, retval;
	char buf[PID_BUF_SIZE] = {0};

	if (pid <= 0)
		return -1;

	snprintf(buf, PID_BUF_SIZE - 1, "%d", pid);
	if (mask)
		fd = open(MASK_EXIT_NOTIFY_DIR, O_WRONLY, 0);
	else
		fd = open(UNMASK_EXIT_NOTIFY_DIR, O_WRONLY, 0);

	if (fd < 0) {
		pr_err("open mask exit notify file fail\n");
		return fd;
	}

	retval = write(fd, buf, PID_BUF_SIZE);
	if (retval < 0)
		pr_err("Write mask exit pid: %s fail\n", buf);
	close(fd);

	return retval < 0 ? -1 : 0;
}
