#ifndef __CRIU_FILES_CHR_H__
#define __CRIU_FILES_CHR_H__

#include "files.h"

#include "images/chr.pb-c.h"

struct chrfile_info {
	struct file_desc d;
	ChrfileEntry *cfe;
	char *path;
};

extern struct collect_image_info chrfile_cinfo;

extern const struct fdtype_ops chr_dump_ops;
extern int collect_chr_map(struct pstree_item *me, struct vma_area *);

int parse_devname(void);
bool find_devname(const char *name);

int collect_chr_map(struct pstree_item *me, struct vma_area *vma);
int is_infiniband_link(char *link);

struct hisi_sec_desc {
	struct hlist_node hash;
	char *name;
	bool mmio;
	bool dus;
	int fd;
};

#define HISI_SEC_DEV	"hisi_sec2"	/* `/dev/hisi_sec2*` char device */

/* here is the selection of offset in `mmap`, they're from drivers */
enum hisi_sec_dev {
	HISI_SEC_MMIO	= 0x0,
	HISI_SEC_DUS	= 0x2000,
};

struct infiniband_file_info {
	InfinibandEntry *infiniband;
	struct file_desc d;
};

extern const struct fdtype_ops infiniband_dump_ops;
extern struct collect_image_info infiniband_cinfo;

#endif /* __CRIU_FILES_CHR_H__ */
