#ifndef __CRIU_NOTIFIER_H__
#define __CRIU_NOTIFIER_H__

#define NOTIFY_PROC_PATH	"/sys/kernel/modrestore/nvwa_notifier"

#if __has_include("linux/modrestore.h")
# define CONFIG_EULEROS_MODRESTORE_NOTIFY /* useless, historical factors */
# include <linux/modrestore.h>
#else
enum KUP_HOOK_POINT {
	PRE_FREEZE,
	FREEZE_TO_KILL,
	PRE_UPDATE_KERNEL,
	POST_UPDATE_KERNEL,
	UNFREEZE_TO_RUN,
	POST_RUN,

	KUP_HOOK_MAX,
};

enum nvwa_cmd {
       PREPARE = 0,
       ROLLBACK,

       NVWA_CMD_MAX,
};
#endif

enum notifier_state {
	NOTHING_COMPLETE,
	PRE_FREEZE_COMPLETE,
	FREEZE_TO_KILL_COMPLETE,
	PRE_UPDATE_KERNEL_COMPLETE,
	POST_UPDATE_KERNEL_COMPLETE,
	UNFREEZE_TO_RUN_COMPLETE,
	POST_RUN_COMPLETE,

	NOTIFIER_ROLLBACK_DONE = 0xfc17173b, /* has done rollback */
};

int notifier_kup(enum KUP_HOOK_POINT, enum nvwa_cmd, bool);
void do_notifier_rollback(bool, enum notifier_state);

#endif /* __CRIU_NOTIFIER_H__ */
