#ifndef __CR_TASKQUEUE_H__
#define __CR_TASKQUEUE_H__

#include <stdbool.h>
#include <pthread.h>
#include <semaphore.h>

#include "vma.h"
#include "pstree.h"

#include "common/list.h"

#define TASKQUEUE_HASH_SIZE	8

struct taskqueue {
	pthread_t task;
	void *(*routine)(void *);
	void *arg;
	int result;
};
#define queue_task	queue.task
#define queue_routine	queue.routine
#define queue_arg	queue.arg
#define queue_result	queue.result

int init_parallel_env(void);

static inline int taskqueue_create(struct taskqueue *queue)
{
	return pthread_create(&queue->task, NULL, queue->routine, queue->arg);
}

static inline int taskqueue_join(struct taskqueue *queue)
{
	return pthread_join(queue->task, NULL);
}

/* parallel collect smaps */
struct mappings_info {
	struct hlist_node hash;
	pid_t pid;
	struct vm_area_list *vmas;
	dump_filemap_t dump_file;
	struct taskqueue queue;
};

int start_collect_mappings_thread(void);
int end_collect_mappings_thread(struct pstree_item *item);

#endif /* __CR_TASKQUEUE_H__ */
