#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include "int.h"
#include "log.h"
#include "orphan-inode.h"

int add_reuse_file(u32 id, int fd, int pid)
{
	int retval;
	char buf[256] = {0};

	retval = snprintf(buf, 256, "%u,%d,%d", id, fd, pid);
	if (retval <= 0)
		return -EFAULT;

	fd = open(ADD_REUSE_FILE_PATH, O_WRONLY, 0);
	if (fd < 0) {
		pr_err("open file:%s fail\n", ADD_REUSE_FILE_PATH);
		return fd;
	}

	retval = write(fd, buf, strlen(buf));
	close(fd);

	return retval < 0 ? -1 : 0;
}

int repair_reuse_file(int id)
{
	int retval, fd;
	char buf[256] = {0};

	retval = snprintf(buf, 256, "%u", id);
	if (retval <= 0)
		return -EFAULT;

	fd = open(REPAIR_REUSE_FILE_PATH, O_WRONLY, 0);
	if (fd < 0) {
		pr_err("open file:%s fail\n", REPAIR_REUSE_FILE_PATH);
		return fd;
	}
	retval = write(fd, buf, strlen(buf));

	close(fd);
	return retval < 0 ? -1 : 0;
}

int get_reuse_file(void)
{
	int fd;
	ssize_t count;
	int retval = -1;
	char buf[32] = {0};

	fd = open(REUSE_FILE_PATH, O_RDONLY , 0);
	if (fd < 0) {
		pr_err("open file:%s fail\n", REUSE_FILE_PATH);
		return fd;
	}

	count = read(fd, buf, sizeof(buf));
	if (count > 0)
		retval = atoi(buf);

	close(fd);
	return retval;
}
